<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.6"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: src/Image.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.6 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">Image.h</div></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#ifndef _IMAGE_H</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="preprocessor">#define _IMAGE_H</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment">//#include &lt;vector&gt;</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="preprocessor">#include &quot;Pixel.h&quot;</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="keyword">using namespace </span>std;</div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno"><a class="line" href="classImage.html">   16</a></span><span class="keyword">class </span><a class="code hl_class" href="classImage.html">Image</a></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>{</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>    <span class="keyword">private</span>:</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span>        <span class="keywordtype">int</span> dimx,dimy;</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span>        <a class="code hl_struct" href="structPixel.html">Pixel</a>* tab;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>    </div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>    <span class="keyword">public</span>:</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>    </div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>    <a class="code hl_function" href="classImage.html#a58edd1c45b4faeb5f789b0d036d02313">Image</a>();</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>    <a class="code hl_function" href="classImage.html#a58edd1c45b4faeb5f789b0d036d02313">Image</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dimensionX, <span class="keywordtype">unsigned</span>  <span class="keywordtype">int</span> dimensionY);</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span> </div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span> </div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>    <a class="code hl_function" href="classImage.html#a0294f63700543e11c0f0da85601c7ae5">~Image</a> ();</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span> </div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span> </div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="classImage.html#afba7efeb769e23a9affa315f451f15f0">isValid</a>(<span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y)<span class="keyword">const</span>;</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span> </div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span> </div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classImage.html#a82ffef6c89927b0cc755a3fe2fec637b">testRegression</a>();</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span> </div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span> </div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>    <a class="code hl_struct" href="structPixel.html">Pixel</a>&amp;  <a class="code hl_function" href="classImage.html#a77a8d8824141ed8b9db62154a211536d">getPix</a> (<span class="keywordtype">int</span> x,<span class="keywordtype">int</span> y);</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span> </div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span> </div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>    <a class="code hl_struct" href="structPixel.html">Pixel</a>  <a class="code hl_function" href="classImage.html#a77a8d8824141ed8b9db62154a211536d">getPix</a>(<span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y) <span class="keyword">const</span>;</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span> </div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span> </div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classImage.html#af7c99d0b4b817fc3bd7840e0428d2f78">setPix</a> (<span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y, <a class="code hl_struct" href="structPixel.html">Pixel</a> couleur);</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span> </div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span> </div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classImage.html#a288917aec4c55beaae0a772ca9f76a53">dessinerRectangle</a>(<span class="keywordtype">int</span> Xmin,<span class="keywordtype">int</span> Ymin,<span class="keywordtype">int</span> Xmax,<span class="keywordtype">int</span> Ymax,<a class="code hl_struct" href="structPixel.html">Pixel</a> couleur);</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>    <span class="comment">// Dessine un rectangle plein de la couleur dans l&#39;image</span></div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>    <span class="comment">// (en utilisant setPix, indices en paramètre compris)</span></div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span> </div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span> </div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classImage.html#ad159951e9564d29f28112ece322c0a97">effacer</a>(<a class="code hl_struct" href="structPixel.html">Pixel</a> couleur);</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span> </div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span> </div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classImage.html#af870cb0c00a370927e6957f99a409586">sauver</a>(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;filename)<span class="keyword">const</span>;</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span> </div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span> </div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classImage.html#a504778b71d66c4da931cad497e2ec249">ouvrir</a>(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;filename);</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span> </div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span> </div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classImage.html#aa3cc6f7401625c11dcd5ef003f37e4fa">afficherConsole</a>();</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span> </div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>    <span class="keywordtype">int</span> <a class="code hl_function" href="classImage.html#a5eb08fc4d14fa9933aa2fd64380eca98">getDimX</a>() <span class="keyword">const</span>;</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span> </div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>    <span class="keywordtype">int</span> <a class="code hl_function" href="classImage.html#a9c46d1bf18fa88b97a6876054f74b795">getDimY</a>() <span class="keyword">const</span>;</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span> </div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>    <span class="keyword">const</span> <a class="code hl_struct" href="structPixel.html">Pixel</a>* <a class="code hl_function" href="classImage.html#a07780f5b37697f1b69a00c843b542dd9">getTab</a>() <span class="keyword">const</span>;</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>};</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span> </div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span> </div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span> </div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span><span class="preprocessor">#endif</span></div>
<div class="ttc" id="aclassImage_html"><div class="ttname"><a href="classImage.html">Image</a></div><div class="ttdoc">this class represents an image</div><div class="ttdef"><b>Definition:</b> Image.h:17</div></div>
<div class="ttc" id="aclassImage_html_a0294f63700543e11c0f0da85601c7ae5"><div class="ttname"><a href="classImage.html#a0294f63700543e11c0f0da85601c7ae5">Image::~Image</a></div><div class="ttdeci">~Image()</div><div class="ttdoc">destructer of the class image</div><div class="ttdef"><b>Definition:</b> Image.cpp:22</div></div>
<div class="ttc" id="aclassImage_html_a07780f5b37697f1b69a00c843b542dd9"><div class="ttname"><a href="classImage.html#a07780f5b37697f1b69a00c843b542dd9">Image::getTab</a></div><div class="ttdeci">const Pixel * getTab() const</div><div class="ttdoc">Obtient une référence constante vers le tableau de pixels.</div><div class="ttdef"><b>Definition:</b> Image.cpp:197</div></div>
<div class="ttc" id="aclassImage_html_a288917aec4c55beaae0a772ca9f76a53"><div class="ttname"><a href="classImage.html#a288917aec4c55beaae0a772ca9f76a53">Image::dessinerRectangle</a></div><div class="ttdeci">void dessinerRectangle(int Xmin, int Ymin, int Xmax, int Ymax, Pixel couleur)</div><div class="ttdoc">draws a rectangle filled with the given pixel in the Image within the right coordinates</div><div class="ttdef"><b>Definition:</b> Image.cpp:109</div></div>
<div class="ttc" id="aclassImage_html_a504778b71d66c4da931cad497e2ec249"><div class="ttname"><a href="classImage.html#a504778b71d66c4da931cad497e2ec249">Image::ouvrir</a></div><div class="ttdeci">void ouvrir(const string &amp;filename)</div><div class="ttdoc">opens an image from a file and replace the current image with the loaded one from the file</div><div class="ttdef"><b>Definition:</b> Image.cpp:146</div></div>
<div class="ttc" id="aclassImage_html_a58edd1c45b4faeb5f789b0d036d02313"><div class="ttname"><a href="classImage.html#a58edd1c45b4faeb5f789b0d036d02313">Image::Image</a></div><div class="ttdeci">Image()</div><div class="ttdoc">default constructer of the class image</div><div class="ttdef"><b>Definition:</b> Image.cpp:7</div></div>
<div class="ttc" id="aclassImage_html_a5eb08fc4d14fa9933aa2fd64380eca98"><div class="ttname"><a href="classImage.html#a5eb08fc4d14fa9933aa2fd64380eca98">Image::getDimX</a></div><div class="ttdeci">int getDimX() const</div><div class="ttdoc">Obtient la largeur de l'image.</div><div class="ttdef"><b>Definition:</b> Image.cpp:189</div></div>
<div class="ttc" id="aclassImage_html_a77a8d8824141ed8b9db62154a211536d"><div class="ttname"><a href="classImage.html#a77a8d8824141ed8b9db62154a211536d">Image::getPix</a></div><div class="ttdeci">Pixel &amp; getPix(int x, int y)</div><div class="ttdoc">fetches the original pixel at the given coordinates (after validation of the coordinates)</div><div class="ttdef"><b>Definition:</b> Image.cpp:89</div></div>
<div class="ttc" id="aclassImage_html_a82ffef6c89927b0cc755a3fe2fec637b"><div class="ttname"><a href="classImage.html#a82ffef6c89927b0cc755a3fe2fec637b">Image::testRegression</a></div><div class="ttdeci">static void testRegression()</div><div class="ttdoc">static method to perform regression testing for the image class</div><div class="ttdef"><b>Definition:</b> Image.cpp:37</div></div>
<div class="ttc" id="aclassImage_html_a9c46d1bf18fa88b97a6876054f74b795"><div class="ttname"><a href="classImage.html#a9c46d1bf18fa88b97a6876054f74b795">Image::getDimY</a></div><div class="ttdeci">int getDimY() const</div><div class="ttdoc">Obtient la hauteur de l'image.</div><div class="ttdef"><b>Definition:</b> Image.cpp:193</div></div>
<div class="ttc" id="aclassImage_html_aa3cc6f7401625c11dcd5ef003f37e4fa"><div class="ttname"><a href="classImage.html#aa3cc6f7401625c11dcd5ef003f37e4fa">Image::afficherConsole</a></div><div class="ttdeci">void afficherConsole()</div><div class="ttdoc">Displays the pixel values on the console.</div><div class="ttdef"><b>Definition:</b> Image.cpp:175</div></div>
<div class="ttc" id="aclassImage_html_ad159951e9564d29f28112ece322c0a97"><div class="ttname"><a href="classImage.html#ad159951e9564d29f28112ece322c0a97">Image::effacer</a></div><div class="ttdeci">void effacer(Pixel couleur)</div><div class="ttdoc">Clears the image by filling it with the specified color.</div><div class="ttdef"><b>Definition:</b> Image.cpp:122</div></div>
<div class="ttc" id="aclassImage_html_af7c99d0b4b817fc3bd7840e0428d2f78"><div class="ttname"><a href="classImage.html#af7c99d0b4b817fc3bd7840e0428d2f78">Image::setPix</a></div><div class="ttdeci">void setPix(int x, int y, Pixel couleur)</div><div class="ttdoc">changes the pixel at the given coordinates (after validation) with the given pixel</div><div class="ttdef"><b>Definition:</b> Image.cpp:102</div></div>
<div class="ttc" id="aclassImage_html_af870cb0c00a370927e6957f99a409586"><div class="ttname"><a href="classImage.html#af870cb0c00a370927e6957f99a409586">Image::sauver</a></div><div class="ttdeci">void sauver(const string &amp;filename) const</div><div class="ttdoc">saves the image to a file</div><div class="ttdef"><b>Definition:</b> Image.cpp:129</div></div>
<div class="ttc" id="aclassImage_html_afba7efeb769e23a9affa315f451f15f0"><div class="ttname"><a href="classImage.html#afba7efeb769e23a9affa315f451f15f0">Image::isValid</a></div><div class="ttdeci">bool isValid(int x, int y) const</div><div class="ttdoc">checks if the given coordinates are valid within the image</div><div class="ttdef"><b>Definition:</b> Image.cpp:32</div></div>
<div class="ttc" id="astructPixel_html"><div class="ttname"><a href="structPixel.html">Pixel</a></div><div class="ttdoc">Represents a pixel with red, green, and blue components.</div><div class="ttdef"><b>Definition:</b> Pixel.h:9</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.6
</small></address>
</body>
</html>
